﻿using ArtOfTest.WebAii.Controls.Xaml.Wpf;
using ArtOfTest.WebAii.Wpf;
using System;

namespace TestModalDialogTest
{
    public static class TimePeriod
    {
        public const int FiveMilliSeconds = 5;
        public const int HalfASecond = 500;
        public const int OneSecond = 1000;
        public const int FiveSeconds = 5000;
        public const int TenSeconds = 10000;
        public const int ThirtySeconds = 30000;
        public const int OneMinute = 60000;
        public const int TwoMinutes = 120000;
   
    }
    public class MainWindow : Window
    {
        public WpfWindow WpfWindow { get; private set; }
    
        /// <summary>
        /// Initialises a new instance of the <see cref="MainWindow"/> class.
        /// </summary>
        /// <param name="wpfWindow">
        /// The wpf window.
        /// </param>
        public MainWindow(WpfWindow wpfWindow)
        {
            this.WpfWindow = wpfWindow;
            wpfWindow.Find.WaitOnElementsTimeout = TimePeriod.OneMinute;
            this.Find.WaitOnElementsTimeout = TimePeriod.OneMinute;
            this.Wait.Timeout = TimePeriod.OneMinute;
        }

        private Button ClickButton;

        public Button ButtonToClick
        {
            get { return this.ClickButton ?? (this.ClickButton = this.WpfWindow.Find.ByType<Button>()); }

        }
        private const int MaxRetries = 3;
      
       public WpfWindow FindModeless()
       {
           var retries = 0;
           WpfWindow window = null;
           while (retries++ < MaxRetries)
           {

               try
               {
                   if (window == null)
                   {
                       window = AppWrap.Application.WaitForWindow("Modeless", TimePeriod.OneSecond * retries); // increasing wait time
                     
                       if (window == null)
                       {
                          continue;
                       }
                   }
                   return window;
               }
               catch (Exception ex)
               {
                   Console.WriteLine(ex.Message);
               }
           }

           return null;
       }

        public void HideModeless()
        {
            // exception here...
            FindModeless().Find.ByType<Button>().User.Click();
        }


    }
}
